"""
Django settings for vacipel project.

Generated by 'django-admin startproject' using Django 5.0.3.

For more information on this file, see
https://docs.djangoproject.com/en/5.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/5.0/ref/settings/
"""
import os
from pathlib import Path
from dotenv import load_dotenv
import dj_database_url
load_dotenv()

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/5.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv('DJ_SECRET')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
#DEBUG = True

ALLOWED_HOSTS = ['*','https://5ea7-177-22-161-187.ngrok-free.app/*']
SECURE_PROXY_SSL_HEADER = ('HTTP_X_FORWARDED_PROTO', 'https')


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'bootstrap5',
    'allauth',
    'pgcrypto',
    'allauth.account',
    'allauth.socialaccount',
    'fontawesomefree',
    'home',
    'perfil',
    'animals',
    'maps',
    'veterinario',
    'vacipel'
]

PGCRYPTO_KEY = os.getenv('DB_ENCRYPT')


#ACCOUNT_EMAIL_VERIFICATION = "none"
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
EMAIL_HOST = os.getenv('GMAIL_HOST')
EMAIL_PORT = 587
EMAIL_USE_TLS = True
EMAIL_HOST_USER = os.getenv('GMAIL_EM')
EMAIL_HOST_PASSWORD = os.getenv('GMAIL_PASS')


SITE_ID= os.getenv('SITE_ID')

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'allauth.account.middleware.AccountMiddleware',

]

ROOT_URLCONF = 'vacipel.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'vacipel/templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'vacipel.wsgi.application'


# Database
# https://docs.djangoproject.com/en/5.0/ref/settings/#databases

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.sqlite3',
#         'NAME': BASE_DIR / 'db.sqlite3',
#     }
# }

import os

# Default to SQLite for local development
DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}

# Check if the environment is set to production
if os.getenv('DJANGO_ENV') == 'production':
    DATABASES = {
        'default':{
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': os.getenv('SUPA_NAME'),
            'USER': os.getenv('SUPA_USER'),
            'PASSWORD': os.getenv('SUPA_SEN'),
            'HOST': os.getenv('SUPA_DB'),
            'PORT': os.getenv('SUPA_POOL'),
    }
}
    
# if os.getenv('DJANGO_ENV') == 'production':
#     DATABASES = {
#         'default': {
#             'ENGINE': 'django_cockroachdb',
#             'NAME': os.getenv('DB_DB'),
#             'USER': os.getenv('DB_USER'),
#             'PASSWORD': os.getenv('DB_PASS'),
#             'HOST': os.getenv('DB_HOST'),
#             'PORT': os.getenv('DB_PORT'),
#             'OPTIONS': {
#                 #'sslmode': 'disable',
#                 'sslmode': 'verify-full',
#                 'sslrootcert': os.path.expandvars(os.getenv('COCKROACHDB_SSLROOTCERT')),
#                 'sslcert': os.path.expandvars(os.getenv('COCKROACHDB_SSLCERT')),
#                 'sslkey': os.path.expandvars(os.getenv('COCKROACHDB_SSLKEY')),
#             },
#         }
#     }



AUTHENTICATION_BACKENDS = [
    'django.contrib.auth.backends.ModelBackend',

    'allauth.account.auth_backends.AuthenticationBackend',
]

# Password validation
# https://docs.djangoproject.com/en/5.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/5.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/5.0/howto/static-files/

STATIC_URL = '/assets/'
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
STATICFILES_DIRS = [os.path.join(BASE_DIR, "static")]
if not DEBUG:
    # Tell Django to copy static assets into a path called `staticfiles` (this is specific to Render)
    STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles')
    # Enable the WhiteNoise storage backend, which compresses static files to reduce disk use
    # and renames the files with unique names for each version to support long-term caching
    STATICFILES_STORAGE = 'whitenoise.storage.CompressedManifestStaticFilesStorage'
    
MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

# Default primary key field type
# https://docs.djangoproject.com/en/5.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

# settings.py

ACCOUNT_FORMS = {'signup': 'perfil.forms.SignupForm',
                'login': 'perfil.forms.LoginForm'}
# ACCOUNT_FORMS = {'signup': 'perfil.forms.CommunSignupForm',
#                  'login': 'perfil.forms.LoginForm'}

ACCOUNT_ADAPTER = 'perfil.adapters.LogInNextAdapter'

# ALL AUTH ITEMS

ACCOUNT_EMAIL_CONFIRMATION_EXPIRE_DAYS=2
ACCOUNT_EMAIL_REQUIRED = True
ACCOUNT_EMAIL_VERIFICATION = "mandatory"
ACCOUNT_SIGNUP_REDIRECT_URL = '/animals/'

# ACCOUNT_LOGIN_ATTEMPTS_TIMEOUT=1800
# ACCOUNT_LOGIN_ATTEMPTS_LIMIT=4

TIME_ZONE = 'America/Sao_Paulo'
LANGUAGE_CODE = 'pt-br'